# VTS Dashboard Notification Samples

## Introduction

The VTS Alert and Performance jobs monitor the Dashboard for changes on a regular
basis. The services notify subscibers via email when attention is required.

## VTS Alert Job

The alerting job monitors for test breakages, fixes, and loss of service. When
new data is uploaded to the database, the alerting job scans for breakages or fixes
and sends emails accordingly. If tests are idle for more than 24 hours, a warning
is sent out as well.

### Sample Email

<div style='border: 1px solid gray; padding: 25px; margin: 20px 0'>
<i><b>Subject:</b> New test failures in SampleCameraV2Test @ 3572205</i><br><br>
Hello,<br><br>Test cases are failing in SampleCameraV2Test for device build ID(s): 3572205.<br><br>
The following test cases failed in the latest test run:<br>
- <b>testCameraNormal</b><br><br><br>

For details, visit the <a href="#">VTS dashboard.</a>
</div>

## VTS Performance Digests

Each day, the VTS Dashboard scans tests which have accompanying performance
data. If so, it compares the past 24 hours to the 24 hours that preceeded it and
summaries the changes in performance.

### Sample Email

<div style='border: 1px solid gray; padding: 25px; margin: 20px 0'>
<i><b>Subject:</b> Daily Performance Digest: BinderPerformanceTest</i><br><br>
<p style='font-family: arial'><b>BinderPerformanceTest</b></p><table cellpadding='2' style='border-collapse: collapse; border: 1px solid black; font-size: 12px; font-family: arial;'><tr><td colspan='7'>binder_vector_roundtrip_latency_benchmark_64bits</td></tr><tr><td colspan='7'>Roundtrip Binder RPC Latency (nanoseconds)</td></tr><tr><th style='border: 1px solid black; border-bottom: none; background-color: lightgray;' ></th><th style='border: 1px solid black; border-bottom: none; background-color: lightgray;' colspan='2'>12-15-2016</th><th style='border: 1px solid black; border-bottom: none; background-color: lightgray;' colspan='2'>12-14-2016</th><th style='border: 1px solid black; border-bottom: none; background-color: lightgray;' colspan='2'>Difference</th></tr><tr><th style='border: 1px solid black; border-bottom-width: 2px; border-top: 1px dotted gray; background-color: lightgray;'>Message Size (Bytes)</th><th style='border: 1px solid black; border-bottom-width: 2px; border-top: 1px dotted gray; background-color: lightgray;'>Mean</th><th style='border: 1px solid black; border-bottom-width: 2px; border-top: 1px dotted gray; background-color: lightgray;'>Std</th><th style='border: 1px solid black; border-bottom-width: 2px; border-top: 1px dotted gray; background-color: lightgray;'>Mean</th><th style='border: 1px solid black; border-bottom-width: 2px; border-top: 1px dotted gray; background-color: lightgray;'>Std</th><th style='border: 1px solid black; border-bottom-width: 2px; border-top: 1px dotted gray; background-color: lightgray;'>Mean</th><th style='border: 1px solid black; border-bottom-width: 2px; border-top: 1px dotted gray; background-color: lightgray;'>Std</th></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>4</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>65263.43</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>16243.85</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>61950.12</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>15198.13</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.05348354679551394);'>3313.32</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.06880574577749773);'>1045.72</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>8</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>62017.23</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>15297.71</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>60683.64</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>14546.73</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.021976199308481374);'>1333.6</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.05162533230917583);'>750.98</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>16</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>59171.27</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>14061.87</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>58840.29</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>14305.1</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.0056250589761115315);'>330.99</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.0);'>-243.23</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>32</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>60201.4</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>13759.66</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>57687.63</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>14320.71</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.04357542043270162);'>2513.77</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.0);'>-561.05</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>64</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>59526</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>13138.61</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>58134.28</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>13776.87</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.02393979154608629);'>1391.73</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.0);'>-638.26</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>128</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>59658.09</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>12699.15</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>58215.99</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>13895.32</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.02477162979154056);'>1442.11</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.0);'>-1196.17</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>256</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>58869.27</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>13307.27</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>57888.51</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>13175.08</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.016942232349139386);'>980.77</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.010033364490373902);'>132.2</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>512</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>60097.32</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>13595.57</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>58211.45</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>13352.47</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.03239680669694265);'>1885.87</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.018206369625088432);'>243.1</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>1024</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>59900.84</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>13540.77</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>58655.61</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>13696.13</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.021229565030634223);'>1245.24</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.0);'>-155.36</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>2k</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>60377.91</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>13060.9</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>60063.71</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>13907.18</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.005231078774897549);'>314.2</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.0);'>-846.27</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>4k</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>77967.83</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>16944.06</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>76550.12</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>18052.7</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.018520011278221876);'>1417.71</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.0);'>-1108.63</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>8k</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>90121.44</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>21365.7</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>87814.47</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>22779.75</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.02627099084257229);'>2306.98</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.0);'>-1414.05</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>16k</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>123431.76</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>24890.05</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>116002.24</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>27537.16</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.06404635766565732);'>7429.53</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.0);'>-2647.11</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>32k</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>179830.98</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>37024.92</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>179219.42</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>40480.43</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.0034123528276210962);'>611.56</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.0);'>-3455.5</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>64k</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>310777.84</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>68022.61</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>325255.19</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>73006.23</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.0);'>-14477.35</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.0);'>-4983.61</td></tr></table><br><table cellpadding='2' style='border-collapse: collapse; border: 1px solid black; font-size: 12px; font-family: arial;'><tr><td colspan='7'>binder_vector_roundtrip_latency_benchmark_32bits</td></tr><tr><td colspan='7'>Roundtrip Binder RPC Latency (nanoseconds)</td></tr><tr><th style='border: 1px solid black; border-bottom: none; background-color: lightgray;' ></th><th style='border: 1px solid black; border-bottom: none; background-color: lightgray;' colspan='2'>12-15-2016</th><th style='border: 1px solid black; border-bottom: none; background-color: lightgray;' colspan='2'>12-14-2016</th><th style='border: 1px solid black; border-bottom: none; background-color: lightgray;' colspan='2'>Difference</th></tr><tr><th style='border: 1px solid black; border-bottom-width: 2px; border-top: 1px dotted gray; background-color: lightgray;'>Message Size (Bytes)</th><th style='border: 1px solid black; border-bottom-width: 2px; border-top: 1px dotted gray; background-color: lightgray;'>Mean</th><th style='border: 1px solid black; border-bottom-width: 2px; border-top: 1px dotted gray; background-color: lightgray;'>Std</th><th style='border: 1px solid black; border-bottom-width: 2px; border-top: 1px dotted gray; background-color: lightgray;'>Mean</th><th style='border: 1px solid black; border-bottom-width: 2px; border-top: 1px dotted gray; background-color: lightgray;'>Std</th><th style='border: 1px solid black; border-bottom-width: 2px; border-top: 1px dotted gray; background-color: lightgray;'>Mean</th><th style='border: 1px solid black; border-bottom-width: 2px; border-top: 1px dotted gray; background-color: lightgray;'>Std</th></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>4</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>56309.18</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>13006.27</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>52456.53</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>9413.16</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.07344467700622763);'>3852.66</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.3817111941575617);'>3593.11</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>8</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>56697.55</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>13180.45</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>52979.84</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>9885.85</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.07017220506617967);'>3717.72</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.3332647598238697);'>3294.61</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>16</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>57496.8</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>12518.8</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>53909.06</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>10273.64</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.0665517258404399);'>3587.75</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.21853593904259516);'>2245.16</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>32</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>57159.51</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>12736.12</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>53308.35</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>10055.59</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.07224310715938732);'>3851.17</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.2665714523398815);'>2680.54</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>64</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>57339.59</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>12823.4</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>53487.21</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>10158.66</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.07202424546046335);'>3852.38</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.26231286775275375);'>2664.75</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>128</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>56847.74</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>13227.75</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>53429.37</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>10033.76</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.0639791653819366);'>3418.37</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.3183236013355946);'>3193.99</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>256</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>56602.05</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>13421.4</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>53552.06</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>10186.89</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.05695376750564279);'>3050</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.31751710651965814);'>3234.51</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>512</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>56847.58</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>13612.71</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>53603.97</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>9695.52</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.060510768173666414);'>3243.62</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.4040216055624986);'>3917.2</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>1024</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>57763.24</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>13104.91</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>54644.6</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>9829.59</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.05707142632570563);'>3118.65</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.3332103586458765);'>3275.33</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>2k</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>59425.7</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>12980.45</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>56566.91</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>9826.89</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.050538310013586586);'>2858.8</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.32091148755758103);'>3153.57</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>4k</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>76829.82</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>15204.6</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>73593.79</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>13091.01</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.04397155961413002);'>3236.04</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.16145347317506317);'>2113.59</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>8k</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>88549.51</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>19759.19</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>82768.58</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>15674.11</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.06984458128993302);'>5780.94</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.2606261864393722);'>4085.09</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>16k</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>112841.27</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>27083.73</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>103774.14</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>21473.39</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.08737362661583523);'>9067.13</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.26126945416091857);'>5610.34</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>32k</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>156421.89</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>42701.39</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>148318.5</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>33647.01</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.05463504947732912);'>8103.39</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.26909911742510617);'>9054.39</td></tr><tr><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right; background-color: lightgray;'>64k</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>272601.44</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>89228.41</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;'>272605.1</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;'>72075.39</td><td style='border-top: 1px dotted gray; border-right: 1px dotted gray; text-align: right;background-color: rgba(255, 0, 0, 0.0);'>-3.65</td><td style='border-top: 1px dotted gray; border-right: 2px solid black; text-align: right;background-color: rgba(255, 0, 0, 0.2379872529135535);'>17153.03</td></tr></table>
</div>
